/*
Critical Mass
Board class definition
Copyright(C) 2002, Jem Berkes <umberkes at cc dot umanitoba dot ca>
*/


class the_board
{
// Internal data
private:
	short width;
	short height;
	uchar* contents;
	
// Public functions
public:
	~the_board();
	the_board();
	the_board(short, short);
	the_board(const the_board&);
	the_board& operator = (const the_board&);
	uchar read_cell(short, short);
	bool move_into_cell(uchar, short, short);
	uchar cell_max_bombs(short, short);
	uchar who_won();
	bool read_lastmove(int&, int&);
	void random_move(uchar);
	void smart_move(uchar);

// Private utility functions
private:
	void copy_from(const the_board&);
	void build();
	void destroy();
	uchar* get_cell(short, short);
	void occupy_cell(short, short, uchar);
	void explode_cells();
	short evaluate();
	the_board find_best_move(uchar, uchar, int&);
};
